From f538254e4658ef5ea4e233c2185dcbfd165e8911 Mon Sep 17 00:00:00 2001
From: Dirk Farin <dirk.farin@gmail.com>
Date: Tue, 5 Apr 2022 18:41:28 +0200
Subject: [PATCH] fix streams where SPS image size changes without refreshing
 PPS (#299)

---
 libde265/decctx.cc | 9 +++++++++
 1 file changed, 9 insertions(+)

diff --git a/libde265/decctx.cc b/libde265/decctx.cc
index edebb7136..6701725fb 100644
--- a/libde265/decctx.cc
+++ b/libde265/decctx.cc
@@ -562,6 +562,15 @@ de265_error decoder_context::read_sps_NAL(bitreader& reader)
 
   sps[ new_sps->seq_parameter_set_id ] = new_sps;
 
+  // Remove the all PPS that referenced the old SPS because parameters may have changed and we do not want to
+  // get the SPS and PPS parameters (e.g. image size) out of sync.
+  
+  for (auto& p : pps) {
+    if (p && p->seq_parameter_set_id == new_sps->seq_parameter_set_id) {
+      p = nullptr;
+    }
+  }
+
   return DE265_OK;
 }
 
